- name: Play to Add VLAN
  hosts: all
  connection: local
  gather_facts: no
  vars: 
    apic_login: &apic_login
      host: "{{ apic_host }}"
      username: "{{ user_var }}"
      password: "{{ user_pass }}"
      validate_certs: no
      use_proxy: False   
      use_ssl: True  
      state: present
    delay_var: 0.1  

  tasks:

    #- name: Create application profile 
    #  aci_ap:
    #   <<: *apic_login
    #   tenant: taxud
    #   ap: "{{ epg.ap }}"
    #  loop: "{{ awx_webhook_payload.data.local_context_data.vlan_add }}"
    #  loop_control:
    #          loop_var: epg
    #          label: "Creating application profile {{ epg.ap }}"
    #          pause: "{{ delay_var }}"
    
    - name: Create VLAN
      block:

        - name: Create bridge domain
          aci_bd: 
           <<: *apic_login
           tenant: taxud
           bd: "{{ epg.vlan_id }}-bd"
           vrf: l2-vrf
           arp_flooding: yes
           l2_unknown_unicast: flood
           use_proxy: no  
           enable_routing: no
          loop: "{{ awx_webhook_payload.data.local_context_data.vlan_add }}"
          loop_control:
                  loop_var: epg
                  label: "Creating bridge domain {{ epg.vlan_id }}-bd"
                  pause: "{{ delay_var }}"

        - name: Create EPG
          aci_epg:
           <<: *apic_login
           tenant: taxud 
           ap: "{{ epg.ap }}"
           epg: "{{ epg.vlan_id }}-epg"
           description: "{{ epg.vlan_desc }}"
           bd: "{{ epg.vlan_id }}-bd"
          loop: "{{ awx_webhook_payload.data.local_context_data.vlan_add }}"
          loop_control:
                  loop_var: epg
                  label: "Creating epg {{ epg.vlan_id }}-epg"
                  pause: "{{ delay_var }}"

        - name: Add VLAN to the VLAN pool
          aci_vlan_pool_encap_block:
           <<: *apic_login
           pool: taxud-vlanpool
           block_name: "{{ epg.vlan_desc }}"
           block_start: "{{ epg.vlan_id }}"
           block_end: "{{ epg.vlan_id }}"
           allocation_mode: inherit
           pool_allocation_mode: static
           description: "{{ epg.subnet }}"
          loop: "{{ awx_webhook_payload.data.local_context_data.vlan_add }}"
          loop_control:
                   loop_var: epg
                   label: "Add VLAN{{ epg.vlan_id }} to taxud-vlanpool"
                   pause: "{{ delay_var }}"

        - name: Assign EPG to the physical domain
          aci_epg_to_domain:
           <<: *apic_login
           tenant: taxud
           ap: "{{ epg.ap }}"
           epg: "{{ epg.vlan_id }}-epg"
           deploy_immediacy: immediate
           domain: taxud-phydom
           domain_type: phys
          loop: "{{ awx_webhook_payload.data.local_context_data.vlan_add }}"
          loop_control:
                  loop_var: epg
                  label: "Assign EPG {{ epg.vlan_id }}-epg to taxud-phydom"
                  pause: "{{ delay_var }}"
      when:
        - awx_webhook_payload.data.local_context_data.vlan_add is defined
        - awx_webhook_payload.data.local_context_data.vlan_add | type_debug == 'list'
        - awx_webhook_payload.data.local_context_data.vlan_add | length > 0
